Index: uspace/lib/net/tl/tl_common.c
===================================================================
--- uspace/lib/net/tl/tl_common.c	(revision 1b11576d37f42974be6406260fc3bcf888c2e19d)
+++ uspace/lib/net/tl/tl_common.c	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -27,47 +27,34 @@
  */
 
-/** @addtogroup libnet 
- * @{
+/** @addtogroup net_tl
+ *  @{
  */
 
 /** @file
- * Transport layer common functions implementation.
- * @see tl_common.h
- */
-
-#include <tl_common.h>
+ *  Transport layer common functions implementation.
+ *  @see tl_common.h
+ */
+
+#include <net/socket_codes.h>
+#include <net/in.h>
+#include <net/in6.h>
+#include <net/inet.h>
+#include <async.h>
+#include <ipc/services.h>
+#include <errno.h>
+#include <err.h>
+
+#include <net/packet.h>
 #include <packet_client.h>
 #include <packet_remote.h>
+#include <net/device.h>
 #include <icmp_interface.h>
 #include <ip_remote.h>
 #include <ip_interface.h>
 #include <tl_interface.h>
-
-#include <net/socket_codes.h>
-#include <net/in.h>
-#include <net/in6.h>
-#include <net/inet.h>
-#include <net/device.h>
-#include <net/packet.h>
-
-#include <async.h>
-#include <ipc/services.h>
-#include <errno.h>
-#include <err.h>
+#include <tl_common.h>
 
 DEVICE_MAP_IMPLEMENT(packet_dimensions, packet_dimension_t);
 
-/** Gets the address port.
- *
- * Supports AF_INET and AF_INET6 address families.
- *
- * @param[in,out] addr	The address to be updated.
- * @param[in] addrlen	The address length.
- * @param[out] port	The set port.
- * @returns		EOK on success.
- * @returns		EINVAL if the address length does not match the address
- *			family.
- * @returns		EAFNOSUPPORT if the address family is not supported.
- */
 int
 tl_get_address_port(const struct sockaddr *addr, int addrlen, uint16_t *port)
@@ -87,13 +74,11 @@
 		*port = ntohs(address_in->sin_port);
 		break;
-	
 	case AF_INET6:
 		if (addrlen != sizeof(struct sockaddr_in6))
-			return EINVAL;
+				return EINVAL;
 
 		address_in6 = (struct sockaddr_in6 *) addr;
 		*port = ntohs(address_in6->sin6_port);
 		break;
-	
 	default:
 		return EAFNOSUPPORT;
@@ -108,17 +93,17 @@
  * The reply is cached then.
  *
- * @param[in] ip_phone	The IP moduel phone for (semi)remote calls.
- * @param[in] packet_dimensions The packet dimensions cache.
- * @param[in] device_id	The device identifier.
- * @param[out] packet_dimension The IP packet dimensions.
- * @return		EOK on success.
- * @return		EBADMEM if the packet_dimension parameter is NULL.
- * @return		ENOMEM if there is not enough memory left.
- * @return		EINVAL if the packet_dimensions cache is not valid.
- * @return		Other codes as defined for the ip_packet_size_req()
- *			function.
- */
-int
-tl_get_ip_packet_dimension(int ip_phone,
+ * @param[in]  ip_phone          The IP moduel phone for (semi)remote calls.
+ * @param[in]  packet_dimensions The packet dimensions cache.
+ * @param[in]  device_id         The device identifier.
+ * @param[out] packet_dimension  The IP packet dimensions.
+ *
+ * @return EOK on success.
+ * @return EBADMEM if the packet_dimension parameter is NULL.
+ * @return ENOMEM if there is not enough memory left.
+ * @return EINVAL if the packet_dimensions cache is not valid.
+ * @return Other codes as defined for the ip_packet_size_req() function.
+ *
+ */
+int tl_get_ip_packet_dimension(int ip_phone,
     packet_dimensions_ref packet_dimensions, device_id_t device_id,
     packet_dimension_ref *packet_dimension)
@@ -154,12 +139,4 @@
 }
 
-/** Updates IP device packet dimensions cache.
- *
- * @param[in,out] packet_dimensions The packet dimensions cache.
- * @param[in] device_id	The device identifier.
- * @param[in] content	The new maximum content size.
- * @returns		EOK on success.
- * @return		ENOENT if the packet dimension is not cached.
- */
 int
 tl_update_ip_packet_dimension(packet_dimensions_ref packet_dimensions,
@@ -171,5 +148,4 @@
 	if (!packet_dimension)
 		return ENOENT;
-
 	packet_dimension->content = content;
 
@@ -184,4 +160,5 @@
 				packet_dimensions_exclude(packet_dimensions,
 				    DEVICE_INVALID_ID);
+
 		}
 	}
@@ -190,16 +167,4 @@
 }
 
-/** Sets the address port.
- *
- * Supports AF_INET and AF_INET6 address families.
- *
- * @param[in,out] addr	The address to be updated.
- * @param[in] addrlen	The address length.
- * @param[in] port	The port to be set.
- * @returns		EOK on success.
- * @returns		EINVAL if the address length does not match the address
- *			family.
- * @returns		EAFNOSUPPORT if the address family is not supported.
- */
 int tl_set_address_port(struct sockaddr * addr, int addrlen, uint16_t port)
 {
@@ -222,5 +187,4 @@
 		address_in->sin_port = htons(port);
 		return EOK;
-	
 	case AF_INET6:
 		if (length != sizeof(struct sockaddr_in6))
@@ -229,5 +193,4 @@
 		address_in6->sin6_port = htons(port);
 		return EOK;
-	
 	default:
 		return EAFNOSUPPORT;
@@ -235,17 +198,4 @@
 }
 
-/** Prepares the packet for ICMP error notification.
- *
- * Keeps the first packet and releases all the others.
- * Releases all the packets on error.
- *
- * @param[in] packet_phone The packet server module phone.
- * @param[in] icmp_phone The ICMP module phone.
- * @param[in] packet	The packet to be send.
- * @param[in] error	The packet error reporting service. Prefixes the
- *			received packet.
- * @returns		EOK on success.
- * @returns		ENOENT if no packet may be sent.
- */
 int
 tl_prepare_icmp_packet(int packet_phone, int icmp_phone, packet_t packet,
@@ -273,18 +223,4 @@
 }
 
-/** Receives data from the socket into a packet.
- *
- * @param[in] packet_phone The packet server module phone.
- * @param[out] packet	The new created packet.
- * @param[in] prefix	Reserved packet data prefix length.
- * @param[in] dimension	The packet dimension.
- * @param[in] addr	The destination address.
- * @param[in] addrlen	The address length.
- * @returns		Number of bytes received.
- * @returns		EINVAL if the client does not send data.
- * @returns		ENOMEM if there is not enough memory left.
- * @returns		Other error codes as defined for the
- *			async_data_read_finalize() function.
- */
 int
 tl_socket_read_packet_data(int packet_phone, packet_ref packet, size_t prefix,
Index: uspace/lib/packet/include/netdb.h
===================================================================
--- uspace/lib/packet/include/netdb.h	(revision 58b833c28450decc06c7a346badd4976170e6cda)
+++ uspace/lib/packet/include/netdb.h	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -0,0 +1,109 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup netdb
+ *  @{
+ */
+
+/** @file
+ *  Structures and interfaces according to the BSD netdb.h file.
+ */
+
+#ifndef __NET_NETDB_H__
+#define __NET_NETDB_H__
+
+#include <sys/types.h>
+
+/** Structure returned by network data base library.
+ *  All addresses are supplied in host order, and returned in network order (suitable for use in system calls).
+ */
+struct	hostent {
+	/** Official host name.
+	 */
+	char * h_name;
+	/** Alias list.
+	 */
+	char **	h_aliases;
+	/** Host address type.
+	 */
+	int h_addrtype;
+	/** Address length.
+	 */
+	int h_length;
+	/** List of addresses from name server.
+	 */
+	char **	h_addr_list;
+	/** Address, for backward compatiblity.
+	 */
+#define	h_addr	h_addr_list[0]
+};
+
+/** @name Host entry address types definitions.
+ */
+/*@{*/
+
+/** Authoritative Answer Host not found address type.
+ */
+#define	HOST_NOT_FOUND	1
+
+/** Non-Authoritive Host not found, or SERVERFAIL address type.
+ */
+#define	TRY_AGAIN	2
+
+/** Non recoverable errors, FORMERR, REFUSED, NOTIMP address type.
+ */
+#define	NO_RECOVERY	3
+
+/** Valid name, no data record of requested type address type.
+ */
+#define	NO_DATA		4
+
+/** No address, look for MX record address type.
+ */
+#define	NO_ADDRESS	NO_DATA
+
+/*@}*/
+
+/** Returns host entry by the host address.
+ *  @param[in] address The host address.
+ *  @param[in] len The address length.
+ *  @param[in] type The address type.
+ *  @returns Host entry information.
+ */
+//struct hostent *	gethostbyaddr(const void * address, int len, int type);
+
+/** Returns host entry by the host name.
+ *  @param[in] name The host name.
+ *  @returns Host entry information.
+ */
+//struct hostent *	gethostbyname(const char * name);
+
+#endif
+
+/** @}
+ */
Index: uspace/lib/packet/include/tcp_codes.h
===================================================================
--- uspace/lib/packet/include/tcp_codes.h	(revision 58b833c28450decc06c7a346badd4976170e6cda)
+++ uspace/lib/packet/include/tcp_codes.h	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -0,0 +1,88 @@
+/*
+ * Copyright (c) 2009 Lukas Mejdrech
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup tcp
+ *  @{
+ */
+
+/** @file
+ *  TCP options definitions.
+ */
+
+#ifndef __NET_TCP_CODES_H__
+#define __NET_TCP_CODES_H__
+
+/** End of list TCP option.
+ */
+#define TCPOPT_END_OF_LIST				0x0
+
+/** No operation TCP option.
+ */
+#define TCPOPT_NO_OPERATION				0x1
+
+/** Maximum segment size TCP option.
+ */
+#define TCPOPT_MAX_SEGMENT_SIZE			0x2
+
+/** Maximum segment size TCP option length.
+ */
+#define TCPOPT_MAX_SEGMENT_SIZE_LENGTH	4
+
+/** Window scale TCP option.
+ */
+#define TCPOPT_WINDOW_SCALE				0x3
+
+/** Window scale TCP option length.
+ */
+#define TCPOPT_WINDOW_SCALE_LENGTH		3
+
+/** Selective acknowledgement permitted TCP option.
+ */
+#define TCPOPT_SACK_PERMITTED			0x4
+
+/** Selective acknowledgement permitted TCP option length.
+ */
+#define TCPOPT_SACK_PERMITTED_LENGTH	2
+
+/** Selective acknowledgement TCP option.
+ *  Has variable length.
+ */
+#define TCPOPT_SACK						0x5
+
+/** Timestamp TCP option.
+ */
+#define TCPOPT_TIMESTAMP				0x8
+
+/** Timestamp TCP option length.
+ */
+#define TCPOPT_TIMESTAMP_LENGTH			10
+
+#endif
+
+/** @}
+ */
Index: uspace/srv/net/il/arp/arp_module.c
===================================================================
--- uspace/srv/net/il/arp/arp_module.c	(revision 1b11576d37f42974be6406260fc3bcf888c2e19d)
+++ uspace/srv/net/il/arp/arp_module.c	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -57,8 +57,23 @@
 extern arp_globals_t	arp_globals;
 
+/** Processes the ARP message.
+ *  @param[in] callid The message identifier.
+ *  @param[in] call The message parameters.
+ *  @param[out] answer The message answer parameters.
+ *  @param[out] answer_count The last parameter for the actual answer in the answer parameter.
+ *  @returns EOK on success.
+ *  @returns Other error codes as defined for the arp_message() function.
+ */
 int il_module_message_standalone(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count){
 	return arp_message_standalone(callid, call, answer, answer_count);
 }
 
+/** Starts the ARP module.
+ *  Initializes the client connection serving function, initializes the module, registers the module service and starts the async manager, processing IPC messages in an infinite loop.
+ *  @param[in] client_connection The client connection processing function. The module skeleton propagates its own one.
+ *  @returns EOK on successful module termination.
+ *  @returns Other error codes as defined for the arp_initialize() function.
+ *  @returns Other error codes as defined for the REGISTER_ME() macro function.
+ */
 int il_module_start_standalone(async_client_conn_t client_connection){
 	ERROR_DECLARE;
Index: uspace/srv/net/il/ip/ip.c
===================================================================
--- uspace/srv/net/il/ip/ip.c	(revision 1b11576d37f42974be6406260fc3bcf888c2e19d)
+++ uspace/srv/net/il/ip/ip.c	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -67,5 +67,4 @@
 #include <ip_client.h>
 #include <ip_interface.h>
-#include <ip_header.h>
 #include <net_interface.h>
 #include <nil_interface.h>
@@ -78,4 +77,5 @@
 
 #include "ip.h"
+#include "ip_header.h"
 #include "ip_module.h"
 #include "ip_local.h"
Index: uspace/srv/net/il/ip/ip_module.c
===================================================================
--- uspace/srv/net/il/ip/ip_module.c	(revision 1b11576d37f42974be6406260fc3bcf888c2e19d)
+++ uspace/srv/net/il/ip/ip_module.c	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -56,8 +56,23 @@
 extern ip_globals_t ip_globals;
 
+/** Processes the IP message.
+ *  @param[in] callid The message identifier.
+ *  @param[in] call The message parameters.
+ *  @param[out] answer The message answer parameters.
+ *  @param[out] answer_count The last parameter for the actual answer in the answer parameter.
+ *  @returns EOK on success.
+ *  @returns Other error codes as defined for the ip_message() function.
+ */
 int il_module_message_standalone(ipc_callid_t callid, ipc_call_t * call, ipc_call_t * answer, int * answer_count){
 	return ip_message_standalone(callid, call, answer, answer_count);
 }
 
+/** Starts the IP module.
+ *  Initializes the client connection serving function, initializes the module, registers the module service and starts the async manager, processing IPC messages in an infinite loop.
+ *  @param[in] client_connection The client connection processing function. The module skeleton propagates its own one.
+ *  @returns EOK on successful module termination.
+ *  @returns Other error codes as defined for the ip_initialize() function.
+ *  @returns Other error codes as defined for the REGISTER_ME() macro function.
+ */
 int il_module_start_standalone(async_client_conn_t client_connection){
 	ERROR_DECLARE;
Index: uspace/srv/net/nil/eth/eth_module.c
===================================================================
--- uspace/srv/net/nil/eth/eth_module.c	(revision 1b11576d37f42974be6406260fc3bcf888c2e19d)
+++ uspace/srv/net/nil/eth/eth_module.c	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -50,4 +50,12 @@
 #include "eth.h"
 
+/** Starts the Ethernet module.
+ *  Initializes the client connection serving function, initializes the module, registers the module service and starts the async manager, processing IPC messages in an infinite loop.
+ *  @param[in] client_connection The client connection processing function. The module skeleton propagates its own one.
+ *  @returns EOK on success.
+ *  @returns Other error codes as defined for the pm_init() function.
+ *  @returns Other error codes as defined for the nil_initialize() function.
+ *  @returns Other error codes as defined for the REGISTER_ME() macro function.
+ */
 int nil_module_start_standalone(async_client_conn_t client_connection)
 {
@@ -71,4 +79,19 @@
 }
 
+/** Pass the parameters to the module specific nil_message() function.
+ *
+ * @param[in]  name         Module name.
+ * @param[in]  callid       The message identifier.
+ * @param[in]  call         The message parameters.
+ * @param[out] answer       The message answer parameters.
+ * @param[out] answer_count The last parameter for the actual answer
+ *                          in the answer parameter.
+ *
+ * @return EOK on success.
+ * @return ENOTSUP if the message is not known.
+ * @return Other error codes as defined for each
+ *         specific module message function.
+ *
+ */
 int nil_module_message_standalone(const char *name, ipc_callid_t callid, ipc_call_t *call,
     ipc_call_t *answer, int *answer_count)
Index: uspace/srv/net/nil/nildummy/nildummy_module.c
===================================================================
--- uspace/srv/net/nil/nildummy/nildummy_module.c	(revision 1b11576d37f42974be6406260fc3bcf888c2e19d)
+++ uspace/srv/net/nil/nildummy/nildummy_module.c	(revision 58b833c28450decc06c7a346badd4976170e6cda)
@@ -50,4 +50,20 @@
 #include "nildummy.h"
 
+/** Start the dummy nil module.
+ *
+ * Initialize the client connection serving function, initialize
+ * the module, register the module service and start the async
+ * manager, processing IPC messages in an infinite loop.
+ *
+ * @param[in] client_connection The client connection processing
+ *                              function. The module skeleton propagates
+ *                              its own one.
+ *
+ * @return EOK on success.
+ * @return Other error codes as defined for the pm_init() function.
+ * @return Other error codes as defined for the nil_initialize() function.
+ * @return Other error codes as defined for the REGISTER_ME() macro function.
+ *
+ */
 int nil_module_start_standalone(async_client_conn_t client_connection)
 {
@@ -71,4 +87,19 @@
 }
 
+/** Pass the parameters to the module specific nil_message() function.
+ *
+ * @param[in]  name         Module name.
+ * @param[in]  callid       The message identifier.
+ * @param[in]  call         The message parameters.
+ * @param[out] answer       The message answer parameters.
+ * @param[out] answer_count The last parameter for the actual answer
+ *                          in the answer parameter.
+ *
+ * @return EOK on success.
+ * @return ENOTSUP if the message is not known.
+ * @return Other error codes as defined for each specific
+ *          module message function.
+ *
+ */
 int nil_module_message_standalone(const char *name, ipc_callid_t callid,
     ipc_call_t *call, ipc_call_t *answer, int *answer_count)
